--三合一面板
require "import"
import "android.widget.*"
import "android.view.*"
import "com.androlua.*"
import "android.content.*"
import "android.text.*"
import "list"
import "list2"
import "list3"

function bianji(vv)
local layout={
LinearLayout,
orientation=1,
layout_width="fill",
{LinearLayout,
orientation=0,layout_width="fill",
{
EditText,
id="edit",
text=vv,
layout_width=-1,
layout_height="80%h",
},},
{LinearLayout,
orientation="horizontal",
layout_height="5%h",
{Button,
text="追加复制",
onClick=function()
service.appendCopy(edit.text)
end,
layout_width="16.6%w",
},
{Button,
text="删除数字",
onClick=function()
edit.text=utf8.gsub(edit.text,"[0-9]+","")
end,
layout_width="16.6%w",
},
{Button,
text="删除中文",
onClick=function()
local txt=edit.text
txt=utf8.gsub(txt,"[\u4e00-\u9fa5-，。？！：；…（）、“”—‘’【】《》]","")
edit.text=txt
end,
layout_width="16.6%w",
},
{Button,
text="删除英文",
onClick=function()
local txt=edit.text
txt=utf8.gsub(txt,"[a-zA-Z,%.%:%!%?%,%~%_@]","")
edit.text=txt
end,
layout_width="16.6%w",
},
{Button,
text="合并连续空白",
onClick=function()
local txt=edit.text
txt=utf8.gsub(txt,"[ ] "," ")
edit.text=txt
end,
layout_width="16.6%w",
},
},
{LinearLayout,
orientation="horizontal",
layout_height="5%h",
{Button,
text="删除空白",
onClick=function()
local txt=edit.text
txt=utf8.gsub(txt,"[ ]","")
edit.text=txt
end,
layout_width="16.6%w",
},
{Button,
text="删除空行",
onClick=function()
local txt=edit.text
txt=utf8.gsub(txt,"\n ","\n")
txt=utf8.gsub(txt,"\r ","\r")
edit.text=txt
end,
layout_width="16.6%w",
},
{Button,
text="删行首空白",
onClick=function()
local txt=edit.text
txt=utf8.gsub(txt,"[ 　]*([^\n]*)","%1")
edit.text=txt
end,
layout_width="16.6%w",
},
{Button,
text="删行尾空白",
onClick=function()
local txt=edit.text
txt=utf8.gsub(txt,"[ ] \n","\n")
txt=utf8.gsub(txt,"%s $","")
edit.text=txt
end,
layout_width="16.6%w",
},
{Button,
text="英文字母转小写",
onClick=function()
local txt=edit.text
txt=utf8.lower(txt)
edit.text=txt
end,
layout_width="16.6%w",
},
{Button,
text="英文字母转大写",
onClick=function()
local txt=edit.text
txt=utf8.upper(txt)
edit.text=txt
end,
layout_width="16.6%w",
},
},
}
bjmb=LuaDialog(service)
bjmb.setView(loadlayout(layout))
bjmb.setButton("添加笔记",function()
tianjia(mc,edit.text)
mb.dismiss()
drml()
end)
bjmb.setButton3("复制到剪切板",function()
service.copy(edit.text)
mb.show()
end)
bjmb.setButton2("添加到收藏",function()
service.addFavorites(edit.text)
mb.show()
end)
bjmb.show()
end

function cfzt(vv)
require"import"
local t1,t2={},{}
for s in vv:gmatch"[^\n]+"
table.insert(t1,s)
end
local dlg=LuaDialog()
.setTitle("共"..table.size(t1).."行")
.setMultiChoiceItems(t1,t2)
.setButton("确定",function()
task(300,function()
service.paste(table.concat(t2))
end)
end)
.show()
dlg.onItemClick=function(l,v,p,i)
v=v.text
te=table.find(t2,v)
if not te
table.insert(t2,v)
else
table.remove(t2,te)
end
end
end

local bjml = "/sdcard/解说/笔记/"
function tianjia(mc,nr)
local edit=loadlayout({LinearLayout,orientation=1,{EditText,id="edit1",hint="名称",text=mc,layout_width=-1},
{EditText,id="edit2",hint="内容",text=nr,layout_width=-1}})
local tjbj=LuaDialog()
tjbj.setView(edit)
tjbj.setButton("确认添加",function()
local file = io.open(bjml..edit1.text, "w")
file:write(edit2.text)
file:close()
tjbj.dismiss()
drml()
mb.show()
end)
tjbj.show()
end

local text={
TextView,
id="tv",
layout_height="5%h",
layout_width="fill",
}
local data,data2,data3,data4={},{},{},{}
local jqb=service.getClipboardList()
local scj=service.getFavoritesList()
for i=0,#jqb-1 do
table.insert(data,{tv=jqb[i]})
table.insert(data4,jqb[i])
end
adapter=LuaAdapter(this,data,text)
for i=0,#scj-1 do
table.insert(data2,{tv=scj[i]})
table.insert(data4,scj[i])
end
adapter2=LuaAdapter(this,data2,text)

local layout = {
LinearLayout;
orientation = 1;
layout_width=-1,
{
EditText,
id="search",
hint="搜索",layout_width=-1,
layout_height="5%h",
},
{
CardView,
layout_width="fill",
layout_height="85%h",
{
PageView,
id="page",
pages={"list2",
"list",
"list3",
}},
},
{LinearLayout,
orientation="horizontal",
layout_width=-1,
layout_height="5%h",
layout_weight=1,
{Button,
text="剪切板管理",
onClick=function()
mb.dismiss()
service.execute("剪切板",node)
end,
layout_width=-1,
layout_weight=1,
},
{Button,
text="收藏夹管理",
onClick=function()
mb.dismiss()
service.execute("收藏夹",node)
end,
layout_width=-1,
layout_weight=1,
},
{Button,
text="云笔记",
onClick=function()
mb.dismiss()
require 'import'
import "android.content.*"
i=Intent()
.setComponent(ComponentName( "com.nirenr.talkman",
"com.nirenr.talkman.settings.CloudNote"))
this.startActivity(i)
end,
layout_width=-1,
layout_weight=1,
},
{Button,
text="添加",
onClick=function()
bianji("","")
end,
layout_width=-1,
layout_weight=1,
},
},
}

local cj={"编辑","拆分粘贴","添加到收藏","添加到笔记"}
local cj2={"编辑","拆分粘贴","复制到剪切板","添加到笔记"}
mb=LuaDialog(this)
mb.setView(loadlayout(layout))
list.adapter=adapter
list2.adapter=adapter2
list3.adapter=adapter3
mb.show()
page.showPage(1)
list.adapter=adapter

list.onItemClick=function(l,v,p,i)
mb.dismiss()
task(200,function()
service.paste(v.text)
end)
end

list.onItemLongClick=function(l,v,p)
local dlg=LuaDialog()
.setItems(cj)
.show()
vv=v.text
dlg.onItemClick=function(l,v,p,i)
dlg.dismiss()
if i==1
bianji(vv)
elseif i==2
cfzt(vv)
mb.dismiss()
elseif i==3
service.addFavorites(vv)
service.speak(vv.."已添加")
else
tianjia("",vv)
drml()
service.speak(vv.."已添加")
end
end
return true
end

list2.onItemClick=function(l,v,p)
mb.dismiss()
task(200,function()
service.paste(v.text)
end)
end

list2.onItemLongClick=function(l,v,p,i)
local dlg=LuaDialog()
.setItems(cj2)
.show()
vv=v.text
dlg.onItemClick=function(l,v,p,i)
if i==1
bianji(vv)
elseif i==2
cfzt(vv)
mb.dismiss()
elseif i==3
service.copy(vv)
service.speak(vv.."已添加")
else
tianjia("",vv)
drml()
service.speak(vv.."已添加")
end
end
return true
end

function drml()
local dir = io.popen("ls -t " .. bjml)
local tab = {}
for i in dir:lines() do
table.insert(tab, i)
end
dir:close()
list3.adapter=SingleLineAdapter(service,String(tab))
end
drml()
list3.onItemClick = function(l,v, p,i)
mb.dismiss()
local file = io.open(bjml..v.text, "r")
bjnr=file:read("a*")
file:close()
task(300,function()
service.paste(bjnr)
end)
end

list3.onItemLongClick=function(l,v,p,i)
local bjcdb={"编辑","复制","删除","添加收藏","发送","拆分粘贴"}
local bjcd=LuaDialog()
bjcd.setItems(bjcdb)
bjcd.show()
mc=v.text
local file = io.open(bjml..v.text, "r")
bjnr=file:read("*a")
file:close()
bjcd.onItemClick=function(l,v,p,i)
bjcd.dismiss()
if i==1
bianji(bjnr)
drml()
elseif i==2
service.copy(bjnr)
elseif i==3
os.remove(bjml..mc)
drml()
elseif i==4
service.addFavorites(bjnr)
elseif i==5
mb.dismiss()
service.shareFile(bjml..mc)
else
cfzt(bjnr)
mb.dismiss()
end
end
return true
end

function updateList(query)
local tab=data4
local jgb = {}
for i =1,#tab-1 do
if tab[i]:lower():find(query:lower(),1,true) then
table.insert(jgb,tab[i])
end
end
service.asyncSpeak(#jgb.."条")
list.adapter.clear()
for _, v in ipairs(jgb) do
list.adapter.add({tv=v})
end
list.adapter.notifyDataSetChanged()
end
search.addTextChangedListener(TextWatcher{onTextChanged = function(s, start, before, count)
tab = updateList(tostring(s))
end,
beforeTextChanged = function(s, start, count, after) end,
afterTextChanged = function(s) end
})

return true